#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int je_cislo(const char *str) {
    char *endptr;
    strtod(str, &endptr);
    return *endptr == '\0';
}

double citaj_cislo(int poradie, int *chyba) {
    char buffer[100];

    if (fgets(buffer, sizeof(buffer), stdin) == NULL) {
        if (poradie == 0) {
            printf("Nepodarilo sa nacitat hodnotu x.\n");
        } else {
            printf("Nepodarilo sa nacitat polynom na %d mieste.\n", poradie);
        }
        *chyba = 1;  
        return NAN;
    }

    char *newline = strchr(buffer, '\n');
    if (newline) *newline = '\0'; 

    if (buffer[0] == '\0') {
        return NAN; 
    }

    if (!je_cislo(buffer)) {
        if (poradie == 0) {
            printf("Nepodarilo sa nacitat hodnotu x.\n");
        } else {
            printf("Nepodarilo sa nacitat polynom na %d mieste.\n", poradie);
        }
        *chyba = 1;
        return NAN;
    }

    return atof(buffer);
}


double hornerova_schema(double *koef, int n, double x) {
    double vysledok = 0.0;
    for (int i = 0; i < n; i++) {
        vysledok = vysledok * x + koef[i];
    }
    return vysledok;
}


int main() {
    double x;
    double koef[100];  
    int n = 0;
    int chyba = 0;


    x = citaj_cislo(0, &chyba);
    if (chyba) return 0;


    while (1) {
        double koeficient = citaj_cislo(n + 1, &chyba);
        if (chyba) return 0;

        if (isnan(koeficient)) break;

        koef[n++] = koeficient;

        if (n >= 100) {
            printf("Chyba: Prilis vela koeficientov.\n");
            return 0;
        }
    }

    if (n == 0) {
        printf("Chyba: Neboli zadane ziadne koeficienty.\n");
        return 0;
    }

    double vysledok = hornerova_schema(koef, n, x);
    printf("Vysledok je: %.2f\n", vysledok);

    return 0;
}
